> ## Documentation Index
> Fetch the complete documentation index at: https://docs.runloop.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Get a Blueprint.

> Get the details of a previously created Blueprint including the build status.



## OpenAPI

````yaml /openapi-specs/stainless-processed-openapi.json get /v1/blueprints/{id}
openapi: 3.1.0
info:
  title: RunLoop API
  version: '0.1'
  description: >-
    The RunLoop API spec that allows you to host lambda functions and Devboxes
    to enable scaled long running ai workflows.
  contact:
    name: Runloop AI Support
    url: https://runloop.ai
    email: support@runloop.ai
servers:
  - url: https://api.runloop.ai
    description: Runloop API
    variables: {}
security:
  - bearerAuth: []
tags:
  - name: Benchmark
  - name: Blueprint
  - name: Blueprint-Lifecycle
  - name: Blueprint-ObservabilityTools
  - name: Devbox
  - name: Devbox-FileTools
  - name: Devbox-Lifecycle
  - name: Devbox-NetworkTools
  - name: Devbox-ObservabilityTools
  - name: Devbox-PersistenceTools
  - name: Devbox-ShellTools
  - name: Scenario
  - name: ScenarioScorer
  - name: accounts
  - name: agents
  - name: apikeys
  - name: axons
  - name: executions
  - name: gateway-configs
  - name: mcp-configs
  - name: network-policies
  - name: objects
  - name: restricted_keys
  - name: secrets
  - name: streaming
paths:
  /v1/blueprints/{id}:
    get:
      tags:
        - Blueprint
        - Blueprint-Lifecycle
      summary: Get a Blueprint.
      description: >-
        Get the details of a previously created Blueprint including the build
        status.
      operationId: getBlueprint
      parameters:
        - name: id
          in: path
          description: The ID of the Blueprint
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BlueprintView'
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Runloop from '@runloop/api-client';

            const client = new Runloop({
              bearerToken: process.env['RUNLOOP_API_KEY'], // This is the default and can be omitted
            });

            const blueprintView = await client.blueprints.retrieve('id');

            console.log(blueprintView.id);
        - lang: Python
          source: |-
            import os
            from runloop_api_client import Runloop

            client = Runloop(
                bearer_token=os.environ.get("RUNLOOP_API_KEY"),  # This is the default and can be omitted
            )
            blueprint_view = client.blueprints.retrieve(
                "id",
            )
            print(blueprint_view.id)
components:
  schemas:
    BlueprintView:
      type: object
      description: >-
        Blueprints are ways to create customized starting points for Devboxes.
        They allow you to define custom starting points for Devboxes such that
        environment set up can be cached to improve Devbox boot times.
      properties:
        id:
          type: string
          description: The id of the Blueprint.
        name:
          type: string
          description: The name of the Blueprint.
        status:
          $ref: '#/components/schemas/BlueprintBuildStatus'
          description: The status of the Blueprint build.
        state:
          $ref: '#/components/schemas/BlueprintState'
          description: The state of the Blueprint.
        create_time_ms:
          type: integer
          format: int64
          description: Creation time of the Blueprint (Unix timestamp milliseconds).
        build_finish_time_ms:
          format: int64
          description: >-
            Build completion time of the Blueprint (Unix timestamp
            milliseconds).
          type:
            - integer
            - 'null'
        parameters:
          $ref: '#/components/schemas/BlueprintBuildParameters'
          description: The parameters used to create Blueprint.
        failure_reason:
          description: The failure reason if the Blueprint build failed, if any.
          anyOf:
            - $ref: '#/components/schemas/BlueprintBuildFailureReason'
            - type: 'null'
        base_blueprint_id:
          description: The ID of the base Blueprint.
          type:
            - string
            - 'null'
        containerized_services:
          items:
            $ref: '#/components/schemas/ContainerizedServiceView'
          description: >-
            List of ContainerizedServices available in the Blueprint. Services
            can be explicitly started when creating a Devbox.
          type:
            - array
            - 'null'
        is_public:
          type: boolean
          description: Whether this Blueprint is publicly accessible to all users.
        metadata:
          additionalProperties:
            type: string
          description: User defined metadata associated with the blueprint.
          type:
            - object
            - 'null'
        devbox_capabilities:
          items:
            $ref: '#/components/schemas/DevboxCapabilities'
          description: Capabilities that will be available on Devbox.
          type:
            - array
            - 'null'
      required:
        - id
        - name
        - status
        - state
        - create_time_ms
        - parameters
    BlueprintBuildStatus:
      type: string
      enum:
        - queued
        - provisioning
        - building
        - failed
        - build_complete
      description: >
        The status of the Blueprint build.


        queued: Blueprint is queued waiting for build capacity to become
        available.

        provisioning: Allocating and booting the necessary infrastructure
        resources to create the Blueprint image.

        building: Building the Blueprint image.

        failed: Blueprint image failed to build. See the logs on the dashboard.

        build_complete: Blueprint image completed build. You can now use the ID
        to create Devboxes.
      x-enum-descriptions:
        queued: Blueprint is queued waiting for build capacity to become available.
        provisioning: >-
          Allocating and booting the necessary infrastructure resources to
          create the Blueprint image.
        building: Building the Blueprint image.
        failed: Blueprint image failed to build. See the logs on the dashboard.
        build_complete: >-
          Blueprint image completed build. You can now use the ID to create
          Devboxes.
    BlueprintState:
      type: string
      enum:
        - created
        - deleted
    BlueprintBuildParameters:
      type: object
      properties:
        name:
          type: string
          description: Name of the Blueprint.
        dockerfile:
          description: Dockerfile contents to be used to build the Blueprint.
          type:
            - string
            - 'null'
        system_setup_commands:
          items:
            type: string
          description: A list of commands to run to set up your system.
          type:
            - array
            - 'null'
        code_mounts:
          items:
            $ref: '#/components/schemas/CodeMountParameters'
          description: A list of code mounts to be included in the Blueprint.
          type:
            - array
            - 'null'
        launch_parameters:
          description: Parameters to configure your Devbox at launch time.
          anyOf:
            - $ref: '#/components/schemas/LaunchParameters'
            - type: 'null'
        file_mounts:
          additionalProperties:
            type: string
          description: (Optional) Map of paths and file contents to write before setup.
          type:
            - object
            - 'null'
        base_blueprint_id:
          description: >-
            (Optional) ID of previously built blueprint to use as a base
            blueprint for this build.
          type:
            - string
            - 'null'
        base_blueprint_name:
          description: >-
            (Optional) Name of previously built blueprint to use as a base
            blueprint for this build. When set, this will load the latest
            successfully built Blueprint with the given name. Only one of
            (base_blueprint_id, base_blueprint_name) should be specified.
          type:
            - string
            - 'null'
        services:
          items:
            $ref: '#/components/schemas/ContainerizedServiceView'
          description: >-
            (Optional) List of containerized services to include in the
            Blueprint. These services will be pre-pulled during the build phase
            for optimized startup performance.
          type:
            - array
            - 'null'
        metadata:
          additionalProperties:
            type: string
          description: (Optional) User defined metadata for the Blueprint.
          type:
            - object
            - 'null'
        build_args:
          additionalProperties:
            type: string
          description: (Optional) Arbitrary Docker build args to pass during build.
          type:
            - object
            - 'null'
        secrets:
          additionalProperties:
            type: string
          description: >-
            (Optional) Map of mount IDs/environment variable names to secret
            names. Secrets will be available to commands during the build.
            Secrets are NOT stored in the blueprint image. Example: {"DB_PASS":
            "DATABASE_PASSWORD"} makes the secret 'DATABASE_PASSWORD' available
            as environment variable 'DB_PASS'.
          type:
            - object
            - 'null'
        build_context:
          description: >-
            (Optional) Build context to be attached to the Blueprint build. This
            context is the source of COPY and ADD directives.
          anyOf:
            - $ref: '#/components/schemas/BuildContext'
            - type: 'null'
        network_policy_id:
          description: >-
            (Optional) ID of the network policy to apply during blueprint build.
            This restricts network access during the build process. This does
            not affect devboxes created from this blueprint; if you want
            devboxes created from this blueprint to inherit the network policy,
            set the network_policy_id on the blueprint launch parameters.
          type:
            - string
            - 'null'
      required:
        - name
    BlueprintBuildFailureReason:
      type: string
      enum:
        - out_of_memory
        - out_of_disk
        - build_failed
      description: >
        The cause of the failure of the Blueprint build.


        out_of_memory: The build has run out of memory. Contact support if this
        is unexpected.

        out_of_disk: The build has run out of disk. Contact support if this is
        unexpected.

        build_failed: The build has failed. Use the dashboard to look at
        Blueprint build logs for more info.
      x-enum-descriptions:
        out_of_memory: >-
          The build has run out of memory. Contact support if this is
          unexpected.
        out_of_disk: The build has run out of disk. Contact support if this is unexpected.
        build_failed: >-
          The build has failed. Use the dashboard to look at Blueprint build
          logs for more info.
    ContainerizedServiceView:
      type: object
      properties:
        name:
          type: string
          description: The name of the container service.
        image:
          type: string
          description: The image of the container service.
        credentials:
          description: The credentials of the container service.
          anyOf:
            - $ref: '#/components/schemas/Credentials'
            - type: 'null'
        env:
          additionalProperties:
            type: string
          description: The environment variables of the container service.
          type:
            - object
            - 'null'
        port_mappings:
          items:
            type: string
          description: >-
            The port mappings of the container service. Port mappings are in the
            format of <host_port>:<container_port>.
          type:
            - array
            - 'null'
        options:
          description: Additional Docker container create options.
          type:
            - string
            - 'null'
      required:
        - name
        - image
    DevboxCapabilities:
      type: string
      enum:
        - unknown
        - docker_in_docker
    CodeMountParameters:
      type: object
      properties:
        repo_name:
          type: string
          description: >-
            The name of the repo to mount. By default, code will be mounted at
            /home/user/{repo_name}.
        repo_owner:
          type: string
          description: The owner of the repo.
        install_command:
          description: Installation command to install and setup repository.
          type:
            - string
            - 'null'
        git_ref:
          description: >-
            Optional git ref (branch or tag) to checkout. Defaults to the
            repository default branch.
          type:
            - string
            - 'null'
        token:
          description: The authentication token necessary to pull repo.
          type:
            - string
            - 'null'
      required:
        - repo_name
        - repo_owner
    LaunchParameters:
      type: object
      description: >-
        LaunchParameters enable you to customize the resources available to your
        Devbox as well as the environment set up that should be completed before
        the Devbox is marked as 'running'.
      properties:
        launch_commands:
          items:
            type: string
          description: >-
            Set of commands to be run at launch time, before the entrypoint
            process is run.
          type:
            - array
            - 'null'
        resource_size_request:
          description: >-
            Preset Devbox resources (vCPU, RAM in GiB, ephemeral disk in GiB).
            If not set, SMALL is used. X_SMALL: 0.5 vCPU, 1 GiB RAM, 4 GiB disk.
            SMALL: 1 vCPU, 2 GiB RAM, 4 GiB disk. MEDIUM: 2 vCPU, 4 GiB RAM, 8
            GiB disk. LARGE: 2 vCPU, 8 GiB RAM, 16 GiB disk. X_LARGE: 4 vCPU, 16
            GiB RAM, 16 GiB disk. XX_LARGE: 8 vCPU, 32 GiB RAM, 16 GiB disk.
            CUSTOM_SIZE: set custom_cpu_cores, custom_gb_memory, and optionally
            custom_disk_size.
          anyOf:
            - $ref: '#/components/schemas/ResourceSize'
            - type: 'null'
        available_ports:
          items:
            type: integer
            format: int32
          description: >-
            [Deprecated] A list of ports to make available on the Devbox. This
            field is ignored.
          type:
            - array
            - 'null'
        keep_alive_time_seconds:
          format: int64
          description: >-
            Time in seconds after which Devbox will automatically shutdown.
            Default is 1 hour. Maximum is 48 hours (172800 seconds).
          type:
            - integer
            - 'null'
        after_idle:
          description: >-
            Configure Devbox lifecycle based on idle activity. If after_idle is
            set, Devbox will ignore keep_alive_time_seconds. If both after_idle
            and lifecycle.after_idle are set, they must have the same value. Use
            lifecycle.after_idle instead.
          anyOf:
            - $ref: '#/components/schemas/IdleConfigurationParameters'
            - type: 'null'
        custom_cpu_cores:
          format: int32
          description: Custom CPU cores. Must be 0.5, 1, or a multiple of 2. Max is 16.
          type:
            - integer
            - 'null'
        custom_gb_memory:
          format: int32
          description: >-
            Custom memory size in GiB. Must be 1 or a multiple of 2. Max is
            64GiB.
          type:
            - integer
            - 'null'
        custom_disk_size:
          format: int32
          description: >-
            Custom disk size in GiB. Must be a multiple of 2. Min is 2GiB, max
            is 64GiB.
          type:
            - integer
            - 'null'
        architecture:
          description: >-
            The target architecture for the Devbox. If unset, defaults to
            x86_64.
          anyOf:
            - $ref: '#/components/schemas/Architecture'
            - type: 'null'
        user_parameters:
          description: >-
            Specify the user for execution on Devbox. If not set, default `user`
            will be used.
          anyOf:
            - $ref: '#/components/schemas/UserParameters'
            - type: 'null'
        required_services:
          items:
            type: string
          description: >-
            A list of ContainerizedService names to be started when a Devbox is
            created. A valid ContainerizedService must be specified in Blueprint
            to be started.
          type:
            - array
            - 'null'
        network_policy_id:
          description: >-
            (Optional) ID of the network policy to apply to Devboxes launched
            with these parameters. When set on a Blueprint launch parameters,
            Devboxes created from it will inherit this policy unless explicitly
            overridden.
          type:
            - string
            - 'null'
        lifecycle:
          description: >-
            Lifecycle configuration for idle and resume behavior. Configure idle
            policy via lifecycle.after_idle (if both this and the top-level
            after_idle are set, they must match), resume triggers via
            lifecycle.resume_triggers, and optional lifecycle hooks via
            lifecycle.lifecycle_hooks.
          anyOf:
            - $ref: '#/components/schemas/LifecycleConfigurationParameters'
            - type: 'null'
        provisioning_tier:
          description: >-
            (Optional, Alpha) standard is default and flex is lazily provisioned
            and may be pre-empted. This is an alpha feature and its behavior may
            change without notice.
          anyOf:
            - $ref: '#/components/schemas/ProvisioningTier'
            - type: 'null'
    BuildContext:
      oneOf:
        - $ref: '#/components/schemas/ObjectContext'
      discriminator:
        propertyName: type
        mapping:
          object:
            $ref: '#/components/schemas/ObjectContext'
    Credentials:
      type: object
      properties:
        username:
          type: string
          description: The username of the container service.
        password:
          type: string
          description: The password of the container service.
      required:
        - username
        - password
    ResourceSize:
      type: string
      enum:
        - X_SMALL
        - SMALL
        - MEDIUM
        - LARGE
        - X_LARGE
        - XX_LARGE
        - CUSTOM_SIZE
      description: >
        The size of the Devbox resources for Runloop to allocate.


        X_SMALL: 0.5 cpu x 1GiB memory x 4GiB disk

        SMALL: 1 cpu x 2GiB memory x 4GiB disk

        MEDIUM: 2 cpu x 4GiB memory x 8GiB disk

        LARGE: 2 cpu x 8GiB memory x 16GiB disk

        X_LARGE: 4 cpu x 16GiB memory x 16GiB disk

        XX_LARGE: 8 cpu x 32GiB memory x 16GiB disk

        CUSTOM_SIZE: To choose a custom size, set this enum and also the
        custom_cpu_cores, custom_gb_memory, and optionally custom_disk_size in
        launch parameters. CPU must be 0.5, 1, or a multiple of 2 (max 16).
        Memory must be 1 or a multiple of 2 (max 64GiB). Disk must be a multiple
        of 2 (min 2GiB, max 64GiB). The cpu:memory ratio must be between 1:2 and
        1:8 inclusive.
      x-enum-descriptions:
        X_SMALL: 0.5 cpu x 1GiB memory x 4GiB disk
        SMALL: 1 cpu x 2GiB memory x 4GiB disk
        MEDIUM: 2 cpu x 4GiB memory x 8GiB disk
        LARGE: 2 cpu x 8GiB memory x 16GiB disk
        X_LARGE: 4 cpu x 16GiB memory x 16GiB disk
        XX_LARGE: 8 cpu x 32GiB memory x 16GiB disk
        CUSTOM_SIZE: >-
          To choose a custom size, set this enum and also the custom_cpu_cores,
          custom_gb_memory, and optionally custom_disk_size in launch
          parameters. CPU must be 0.5, 1, or a multiple of 2 (max 16). Memory
          must be 1 or a multiple of 2 (max 64GiB). Disk must be a multiple of 2
          (min 2GiB, max 64GiB). The cpu:memory ratio must be between 1:2 and
          1:8 inclusive.
    IdleConfigurationParameters:
      type: object
      properties:
        idle_time_seconds:
          type: integer
          format: int32
          description: After idle_time_seconds, on_idle action will be taken.
        on_idle:
          $ref: '#/components/schemas/IdleAction'
          description: Action to take after Devbox becomes idle.
      required:
        - idle_time_seconds
        - on_idle
    Architecture:
      type: string
      enum:
        - x86_64
        - arm64
    UserParameters:
      type: object
      description: Configuration for the Linux user in the Devbox environment.
      properties:
        username:
          type: string
          description: Username for the Linux user.
        uid:
          type: integer
          format: int32
          description: User ID (UID) for the Linux user. Must be a non-negative integer.
      required:
        - username
        - uid
    LifecycleConfigurationParameters:
      type: object
      description: >-
        Lifecycle configuration for Devbox idle and resume behavior. Configure
        idle policy via after_idle, resume triggers via resume_triggers, and
        optional lifecycle hooks via lifecycle_hooks.
      properties:
        after_idle:
          description: >-
            Configure Devbox lifecycle based on idle activity. If both this and
            the top-level after_idle are set, they must have the same value.
            Prefer this field for new integrations.
          anyOf:
            - $ref: '#/components/schemas/IdleConfigurationParameters'
            - type: 'null'
        resume_triggers:
          description: Triggers that can resume a suspended Devbox.
          anyOf:
            - $ref: '#/components/schemas/ResumeTriggers'
            - type: 'null'
        lifecycle_hooks:
          description: >-
            Optional lifecycle hooks. suspend_commands run through the suspend
            path before the Devbox suspends; see launch_commands for work on
            every startup.
          anyOf:
            - $ref: '#/components/schemas/LifecycleHooks'
            - type: 'null'
    ProvisioningTier:
      type: string
      enum:
        - standard
        - flex
    ObjectContext:
      type: object
      description: A build context backed by an Object.
      properties:
        object_id:
          type: string
          description: >-
            The ID of an object, whose contents are to be used as a build
            context.
        type:
          type: string
          enum:
            - object
          default: object
      required:
        - object_id
        - type
    IdleAction:
      type: string
      enum:
        - shutdown
        - suspend
      description: |
        Action to take after Devbox idle timer is triggered.

        shutdown: Shutdown the Devbox.
        suspend: Suspend the Devbox.
      x-enum-descriptions:
        shutdown: Shutdown the Devbox.
        suspend: Suspend the Devbox.
    ResumeTriggers:
      type: object
      description: Triggers that can resume a suspended Devbox.
      properties:
        http:
          description: >-
            When true, HTTP traffic to a suspended Devbox via tunnel will
            trigger a resume.
          type:
            - boolean
            - 'null'
        axon_event:
          description: >-
            When true, axon events targeting a suspended Devbox will trigger a
            resume.
          type:
            - boolean
            - 'null'
    LifecycleHooks:
      type: object
      description: >-
        Lifecycle hooks for Devbox suspend. suspend_commands run sequentially as
        the configured Devbox user before the Devbox suspends; failures are
        logged but do not block suspending. The suspend_deadline_ms budget
        defaults to 30000 ms, may not exceed 60000 ms, and covers broker drain
        plus suspend_commands. If the deadline is exceeded, suspend work is
        abandoned, the timeout is logged, and the Devbox still proceeds to
        suspend. launch_commands still run on every startup, including after
        resume.
      properties:
        suspend_commands:
          items:
            type: string
          description: >-
            Commands to run through the suspend path before the Devbox suspends
            (e.g. cleanup, quiesce daemons).
          type:
            - array
            - 'null'
        suspend_deadline_ms:
          format: int64
          description: >-
            Deadline in milliseconds for broker drain and suspend_commands
            during suspend. Defaults to 30000 ms and may not exceed 60000 ms. If
            exceeded, suspend work is abandoned, the timeout is logged, and the
            Devbox still proceeds to suspend by shutting down vmagent and
            killing the VM.
          type:
            - integer
            - 'null'
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http

````